// Labelling.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"

//vWFNg̃vpeBC/C++ˑSʁ@̒ǉ̃CN[hfBNg
// wC:\OpenCV2.2\includexǉ̂
#include "opencv2\\opencv.hpp"
 
#ifdef _DEBUG
    //Debug[h̏ꍇ
    #pragma comment(lib,"C:\\OpenCV2.2\\lib\\opencv_core220d.lib")
    #pragma comment(lib,"C:\\OpenCV2.2\\lib\\opencv_imgproc220d.lib")
    #pragma comment(lib,"C:\\OpenCV2.2\\lib\\opencv_highgui220d.lib")
#else
    //Release[h̏ꍇ
    #pragma comment(lib,"C:\\OpenCV2.2\\lib\\opencv_core220.lib")
    #pragma comment(lib,"C:\\OpenCV2.2\\lib\\opencv_imgproc220.lib")
    #pragma comment(lib,"C:\\OpenCV2.2\\lib\\opencv_highgui220.lib")
#endif

// ֐錾
void GetContourFeature(CvSeq*);
void DrawChildContour(IplImage*, CvSeq*,int);
void DrawNextContour(IplImage*,	CvSeq*, int);
void cv_Labelling(IplImage*, IplImage*);

//e֊s̓ʂ̎擾
void GetContourFeature(CvSeq *Contour){
	//ʐ
	double Area = fabs(cvContourArea(Contour, CV_WHOLE_SEQ));
	//͒
	double Perimeter = cvArcLength(Contour);
	//~`x
	double CircleLevel = 4.0 * CV_PI * Area / (Perimeter * Perimeter);

	//XĂȂOڎlp`̈itBaj
	CvRect rect = cvBoundingRect(Contour);
	//֊s\钸_W擾
	for ( int i = 0; i < Contour->total; i++){
		CvPoint *point = CV_GET_SEQ_ELEM (CvPoint, Contour, i);
	}
}

void DrawChildContour(	//q̗֊s`悷B
	IplImage *img,	//xOʂ`悷IplImage(8Bit3chJ[j
	CvSeq *Contour, //֊sւ̃|C^
	int Level		//֊s̃xiKwj
	){
			 
	// ̈̐F
	CvScalar color;	
	// ֊s`悷F̐ݒ
	CvScalar ContoursColor;

	if ((Level % 2) == 1){
		//̗֊s̏ꍇ
		// ̈̐F
		color = CV_RGB( rand()&255, rand()&255, rand()&255 );
		// ֊s̐F
		ContoursColor = CV_RGB( 255, 0, 0 );

	}else{
		//̗֊s̏ꍇȉꍇj
		// ̈̐F
		color = CV_RGB(0, 0, 0);
		// ֊s̐F
		ContoursColor = CV_RGB( 0, 0, 255 );
	}
			 
	//֊s̕`
	cvDrawContours( img, Contour, color, color, 0, CV_FILLED);			// ̈
	cvDrawContours( img, Contour, ContoursColor, ContoursColor, 0, 2);	// ֊s

	//֊s\钸_W擾
	for ( int i = 0; i < Contour->total; i++){
		CvPoint *point = CV_GET_SEQ_ELEM (CvPoint, Contour, i);
		//cvDrawCircle(img, *point, 3, CV_RGB(0, 255, 0));
	}
		 
	//e֊s̓ʂ̎擾
	GetContourFeature(Contour);

	if (Contour->h_next != NULL)
		//̗֊sꍇ͎̗֊s`
		DrawNextContour(img, Contour->h_next, Level);

	if (Contour->v_next != NULL)
		//q̗֊sꍇ͎q̗֊s`
		DrawChildContour(img, Contour->v_next, Level + 1);
}

void DrawNextContour(	//̗֊s`悷B
	IplImage *img,	//xOʂ`悷IplImage(8Bit3chJ[j
	CvSeq *Contour, //֊sւ̃|C^
	int Level		//֊s̃xiKwj
	){

	// ̈̐F
	CvScalar color;
	// ֊s`悷F̐ݒ
	CvScalar ContoursColor;

	if ((Level % 2) == 1){
		//̗֊s̏ꍇ
		// ̈̐F
		color = CV_RGB( rand()&255, rand()&255, rand()&255 );
		// ֊s̐F
		ContoursColor = CV_RGB( 255, 0, 0 );

	}else{
		//̗֊s̏ꍇȉꍇj
		// ̈̐F
		color = CV_RGB(0, 0, 0);
		// ֊s̐F
		ContoursColor = CV_RGB( 0, 0, 255 );
	}
			 
	//֊s̕`
	cvDrawContours( img, Contour, color, color, 0, CV_FILLED);			// ̈
	cvDrawContours( img, Contour, ContoursColor, ContoursColor, 0, 2);	// ֊s

	//֊s\钸_W擾
	for ( int i = 0; i < Contour->total; i++){
		CvPoint *point = CV_GET_SEQ_ELEM (CvPoint, Contour, i);
		// _W̕`
		//cvDrawCircle(img, *point, 3, CV_RGB(0, 255, 0));
	}

	//e֊s̓ʂ̎擾
	GetContourFeature(Contour);

	if (Contour->h_next != NULL)
		//̗֊sꍇ͎̗֊s`
		DrawNextContour(img, Contour->h_next, Level);

	if (Contour->v_next != NULL)
		//q̗֊sꍇ͎q̗֊s`
		DrawChildContour(img, Contour->v_next, Level + 1);
}
 
void cv_Labelling(	//xO
	IplImage *src,	//͉摜i8BitmNj
	IplImage *dst	//o͉摜i8Bit3chJ[j
	) {
			 
	CvMemStorage *storage = cvCreateMemStorage (0); 
	CvSeq *contours = NULL; 
			 
	if (src == NULL)    
		return;  
		 
	// 摜̓lyʕ͖@(Â̓l)z
	cvThreshold (src, src, 0, 255, CV_THRESH_BINARY | CV_THRESH_OTSU);

	// ֊šo(߂l͎擾֊s̑S)
	int find_contour_num = cvFindContours (
			src,					// ͉摜
			storage,				// oꂽ֊sۑ̈
			&contours,				// ԊO̗֊sւ̃|C^ւ̃|C^
			sizeof (CvContour),		// V[PXwb_̃TCY
			CV_RETR_TREE,			// o[h
									// CV_RETR_EXTERNAL - łO̗֊ŝݒo
									// CV_RETR_LIST - SĂ̗֊s𒊏oCXgɒǉ
									// CV_RETR_CCOMP - SĂ̗֊s𒊏oC̃xKw\\D1Ԗڂ̃x͘ÅŐEC2Ԗڂ̃x͌iA̓ɑ݂j̋ED
									// CV_RETR_TREE - SĂ̗֊s𒊏oC}ꂵ֊sSɕ\Kw\\D
			CV_CHAIN_APPROX_SIMPLE	// CV_CHAIN_APPROX_SIMPLE:֊s̐܂̒[_擾
									// CV_CHAIN_APPROX_NONE: ֊s̑SĂ̓_擾 
									// CV_CHAIN_APPROX_TC89_L1		:Teh-Chin`F[̋ߎASŸKp
									// CV_CHAIN_APPROX_TC89_KCOS
			);

	if (contours != NULL){
		//摜Oijŏ
		cvZero(dst);
		//֊s̕`
		DrawNextContour(dst, contours, 1);
	}

	//Xg[W̉
	cvReleaseMemStorage (&storage);

}

int _tmain(int argc, _TCHAR* argv[])
{

    //摜f[^̓ǍiO[XP[œǍj
    IplImage* src = cvLoadImage("sample.bmp", CV_LOAD_IMAGE_GRAYSCALE);
    if (src == NULL){
        return 0;
    }
 
    //\EBhE̍쐬
    cvNamedWindow("src");
    cvNamedWindow("dst");

    //摜f[^̊m
    IplImage* dst = cvCreateImage(cvGetSize(src), src->depth, 3);

	// ͉摜̕\
	cvShowImage ("src", src);
 
    // xOi͉摜(src)cvFindContoursɂύX܂Bj
    cv_Labelling(src, dst);
 
    // xO摜̕\
    cvShowImage ("dst", dst);
 
    // L[͑҂
    cvWaitKey (0);
 
    // SẴEBhE̍폜
    cvDestroyAllWindows();
 
    // 摜f[^̉
    cvReleaseImage(&src);
    cvReleaseImage(&dst);
 
	return 0;
}

